/* Kompilator konfiguraku na web
 * error a warning
 * (c)23.10.1999 by Marek Zelem
 */

#include <mmm/compiler.h>
#include <mmm/lex.h>
#include <mmm/dynamic.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "web_compile.h"

extern lextab_t operators[];
extern lextab_t keywords[];

int warning( char *format, ... )
{ va_list ap;
	va_start(ap,format);
	printf("Warning: V \"%s\" na riadku %d (stlpec %d) ",compiler->lex->filename,compiler->lex->row,compiler->lex->col);
	vprintf(format,ap);
	printf("\n");
	va_end(ap);
	err_tab.warnings++;
	return(0);
}

int error( char *format, ... )
{ va_list ap;
	va_start(ap,format);
	printf("Error: V \"%s\" na riadku %d (stlpec %d) ",compiler->lex->filename,compiler->lex->row,compiler->lex->col);
	vprintf(format,ap);
	printf("\n");
	va_end(ap);
	err_tab.errors++;
	return(0);
}

static char *sym2str( sym_t sym )
{ lextab_t *l=keywords;
	if( sym==TEND )	return("koniec suboru");
	if( sym==Lid )	return("slovo");
	if( sym==Lstr )	return("retazec");
	while(l->keyword!=NULL)
	{	if( l->sym==sym )
			return(l->keyword);
		l++;
	}
	l=operators;
	while(l->keyword!=NULL)
	{	if( l->sym==sym )
			return(l->keyword);
		l++;
	}
	return("???");
}
static sym_t e_warning( struct compiler_err_class *this, sym_t errsym, sym_t info )
{
	if( errsym==TEND )	return(0);
	if( errsym==END && (info&TYP)==E )
		warning("je lexikalne varovanie %04x",info&~TYP);
	else if( errsym==Wvzor && info==END )
		warning("je viacnasobne definovana sablona");
	else if( errsym==Wsecnoefe && info==END )
		warning("je sekcia bez efektu");
	else if( (errsym&TYP)==W && info==END )
		warning("je varovanie %04x",errsym&~TYP);
	else	warning("je varovanie %04x %04x",errsym,info);
	return(0);
}
static sym_t e_error( struct compiler_err_class *this, sym_t errsym, sym_t info )
{
	if( errsym==TEND )	return(0);
	if( errsym==END && info==eLEXERR )
		error("je lexikalna chyba");
	else if( errsym==Efile || info==Efile )
		error("nemozem nacitat subor");
	else if( errsym==END && (info&TYP)==E )
		error("je lexikalna chyba %04x",info&~TYP);
	else if( errsym==END && ((info&TYP)==T || info==TEND) )
		error("nemoze byt %s",sym2str(info));
	else if( (errsym&TYP)==T && ((info&TYP)==T || info==TEND) )
		error("malo byt %s",sym2str(errsym));
	else if( errsym==Evzor && info==END )
		error("nieje definovana sablona");
	else if( errsym==Euprav_vzor && info==END )
		error("doslo k chybe pri pouziti sablony");
	else if( (errsym&TYP)==E && info==END )
		error("je chyba %04x",errsym&~TYP);
	else	error("je chyba %04x %04x",errsym,info);
	return(0);
}

static void err_destroy( struct compiler_err_class *this )
{	return;
}

struct compiler_err_class err_tab={
	err_destroy,
	0,
	e_warning,e_error,0,0
};

