/* Kompilator konfiguraku na web
 * Suborove funkcie
 * (c)23.10.1999 by Marek Zelem
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "web_compile.h"

char *file2str( char *filename )
{ char *mem;
  struct stat st;
  int fd;
	if( (fd=open(filename,O_RDONLY))<0 )    return(NULL);
	if( fstat(fd,&st)!=0 )
	{	close(fd);	return(NULL);	}
	if( (mem=malloc(st.st_size+1))==NULL )
	{	close(fd);	return(NULL);	}
	if( read(fd,mem,st.st_size)!=st.st_size )
	{	free(mem);	close(fd);	return(NULL);	}
	close(fd);
	mem[st.st_size]=0;
	return(mem);
}

int make_dirs( char *fn )
{ int i;
  struct stat st;
  	i=0;
	while( fn[i]!=0 )
	{	while( fn[i]!=0 && fn[i]!='/' )	i++;
		if( i==0 && fn[i]=='/' )	{ i++; continue; }
		if( fn[i]==0 )	return(0);
		fn[i]=0;
		if( stat(fn,&st)>=0 )
		{	if( !S_ISDIR(st.st_mode) )
			{	fn[i]='/';
				return(-1);
			}
		}
		else
		{	if( mkdir(fn,0777)<0 )
			{	fn[i]='/';
				return(-1);
			}
		}
		fn[i]='/';
		while( fn[i]=='/' )	i++;
	}
	return(0);
}

int data2file( char *fn, char *data )
{ int fd,l;
	if( make_dirs(fn)<0 )		return(-1);
	if( (fd=open(fn,O_WRONLY|O_CREAT|O_TRUNC,0666))<0 )	return(-1);
	l=strlen(data);
	if( write(fd,data,l)!=l )
	{	close(fd);	return(-1);	}
	close(fd);
	return(0);
}

int linkfile( char *fn, char *from )
{ 
	if( make_dirs(fn)<0 )		return(-1);
	symlink(from,fn);
	return(0);
}

int copyfile( char *fn, char *from )
{ int f,t,l;
  char buf[8192];
	if( make_dirs(fn)<0 )		return(-1);
	if( (t=open(fn,O_WRONLY|O_CREAT|O_TRUNC,0666))<0 )	return(-1);
	if( (f=open(from,O_RDONLY))>=0 )
	{	while( (l=read(f,buf,8192))>0 )
			write(t,buf,l);
		close(f);
	}
	else	warning("Nemozem otvorit subor \"%s\"",from);
	close(t);
	return(0);
}

char *filter( char *in, char *prog, char *arg )
{ darg_t *da;
  ddata_t *dd;
  char **av;
  int p1[2],p2[2];
  int l;
  char buf[1024];
  pid_t pid1,pid2;
  int st,ign=0;
  	if( *prog=='@' )
	{	ign=1;	prog++;		}
	if( (da=darg_str2argv(prog,0))==NULL )
	{	error("Filter error");
		return(NULL);
	}
	if( arg!=NULL )
		darg_append(da,arg);
	av=darg_argv(da);
	pipe(p1);
	switch( (pid1=fork()) )
	{	case 0: close(p1[0]);
			write(p1[1],in,strlen(in));
			close(p1[1]);
			exit(0);
		case -1:
			error("Filter fork error");
			close(p1[0]); close(p1[1]);
			return(NULL);
	}
	close(p1[1]);
	pipe(p2);
	switch( (pid2=fork()) )
	{	case 0:	close(p2[0]);
			close(0);	dup(p1[0]);	close(p1[0]);
			close(1);	dup(p2[1]);	close(p2[1]);
			execvp(av[0],av);
			exit(1);
		case -1:
			error("Filter fork error");
			close(p1[0]);
			close(p2[0]); close(p2[1]);
			waitpid(pid1,NULL,0);
			return(NULL);
	}
	close(p1[0]);
	close(p2[1]);
	dd=dd_alloc(1,1024);
	while( (l=read(p2[0],buf,1024))>0 )
		dd_append(dd,buf,l);
	close(p2[0]);
	buf[0]=0;	dd_append(dd,buf,1);
	darg_free(da);
	waitpid(pid1,NULL,0);
	waitpid(pid2,&st,0);
	if( !ign && (!WIFEXITED(st) || WEXITSTATUS(st)!=0) )
	{	dd_free(dd);
		error("Filter program error");
		return(NULL);
	}
	return(dd_extract(dd));
}

