/* Kompilator konfiguraku na web
 * Generovanie menu
 * (c)6.11.1999 by Marek Zelem
 */

#include <stdlib.h>
#include <string.h>
#include <mmm/dynamic.h>
#include "web_compile.h"

mnu_t *new_menu( void )
{ mnu_t *m=malloc(sizeof(mnu_t));
	m->next=m->last_sub=m->sub=NULL;
	m->nazov=m->popis=m->subor=NULL;
	m->typ=0;
	return(m);
}
void del_menu( mnu_t *m )
{	if( !m )	return;
//printf("deletujem menu %s\n",m->nazov);
	if( m->next )	del_menu(m->next);
	if( m->sub )	del_menu(m->sub);
//printf("dorazam menu %s\n",m->nazov);
	if( m->nazov )	free(m->nazov);
//printf("xxx\n");
	if( m->popis )	free(m->popis);
//printf("xxx\n");
	if( m->subor )	free(m->subor);
//printf("xxx\n");
	free(m);
//printf("dorazene\n");
}

void add_submenu( mnu_t *m, mnu_t *sub )
{
	sub->next=NULL;
	if( m->last_sub==NULL )
		m->sub=m->last_sub=sub;
	else
		m->last_sub=(m->last_sub->next=sub);
	
}

void add_nsubmenu( mnu_t *m, int n, char *popis )
{ mnu_t *s;
  char buf[128];
	s=new_menu();
	sprintf(buf,"#%d",n);
	s->subor=strdup(buf);
	s->nazov=NULL;
	if( popis!=NULL )	s->popis=strdup(popis);
	else			s->popis=NULL;
	add_submenu(m,s);
}

void oprav_menu( mnu_t *m, mnu_t *s )
{ char *p,buf[128];
//printf("Opravujem menu %s\n",s->nazov);
	if( s->subor[0]=='#' )
	{	p=s->subor;
		sprintf(buf,"%s%s",m->subor,p);
		s->subor=strdup(buf);
		if( s->nazov==NULL )
		{	sprintf(buf,"%s_%s",m->nazov,p+1);
			s->nazov=strdup(buf);
		}
		if( s->popis==NULL )
		{	sprintf(buf,"%s",p+1);
			s->popis=strdup(buf);
		}
		free(p);
	}
	if( (s->nazov==NULL || !strcmp(s->nazov,"hidden")) && s->sub!=NULL )
	{	if( (s->last_sub->next=s->next)==NULL )
			m->last_sub=s->last_sub;
		s->next=s->sub;
		s->sub=s->last_sub=NULL;
	}
	if( s->nazov!=NULL && !strcmp(s->nazov,"hidden") )
	{	free(s->nazov);
		s->nazov=NULL;
	}
}

static int generuj_php_submenu( ddata_t *d, mnu_t *m )
{
//printf("sub z %p\n",m);
//printf("sub z %s\n",m->nazov);
	if( m->sub==NULL && !(m->typ&M_INCL) )
	{	dd_printf(d,"NULL");
		return(0);
	}
	dd_printf(d,"array ( ");
	if( (m->typ&M_INCL) )
	{	dd_printf(d,"\"%s\"",m->nazov);
		if( m->sub!=NULL )	dd_printf(d,",");
	}
	m=m->sub;
	while( m!=NULL )
	{	if( m->nazov )
		{	dd_printf(d,"\"%s\"",m->nazov);
			m=m->next;
			if( m!=NULL )	dd_printf(d,",");
		}
		else	m=m->next;
	}
	dd_printf(d," )");
	return(1);
}

static int generuj_php_menu( ddata_t *d, mnu_t *m )
{ mnu_t *s;
//printf("Generujem php menu %s\n",m->nazov);
	if( m->nazov==NULL )	return(0);
	dd_printf(d,"$%s = array ( ",m->nazov);
	dd_printf(d,"\"linka\" => \"%s\",\n",m->subor);
	dd_printf(d,"\t\"popis\" => \"%s\",\n",m->popis);
	dd_printf(d,"\t\"podmenu\" => ");
	if( (m->typ&M_INCL) )
	{	dd_printf(d,"NULL );\n");
		return(0);
	}
	s=m->sub;
	while( s!=NULL )
	{	oprav_menu(m,s);
		s=s->next;
	}
	generuj_php_submenu( d, m );
	dd_printf(d,");\n");
	s=m->sub;
	while( s!=NULL )
	{	generuj_php_menu(d,s);
		s=s->next;
	}
//printf("Vygenerovane php menu %s\n",m->nazov);
	return(0);
}

char *sprav_menu( sekcia_t *s )
{ ddata_t *d;
  static char *menu=NULL;
  static sekcia_t *sec=NULL;
  mnu_t *m;
  	if( s==sec )		return(menu);
	if( menu!=NULL )	{ free(menu); menu=NULL; }
	sec=s;
	if( s==NULL )		return(NULL);
	
//printf("zacinam robit menu\n");
	if( (d=dd_alloc(1,128))==NULL )
		return(NULL);
	m=s->menu->sub;
	while( m!=NULL )
	{	oprav_menu(s->menu,m);
		m=m->next;
	}
	dd_printf(d,"$menu = ");
	generuj_php_submenu( d, s->menu );
	dd_printf(d,";\n");
	if( (s->menu->typ&M_INCL) )
		generuj_php_menu(d,s->menu);
	m=s->menu->sub;
	while( m!=NULL )
	{	generuj_php_menu(d,m);
//printf("m=%p\n",m);
//printf("m->next=%p\n",m->next);
		m=m->next;
	}
//printf("Zijem 1\n");
	if( s->menu->sub != NULL )
		del_menu(s->menu->sub);
//printf("Zijem 2\n");
	s->menu->sub=s->menu->last_sub=NULL;
//printf("Zijem 3\n");
	dd_tostring(d);
//printf("Zijem 4\n");
	return( (menu=dd_extract(d)) );
}

