/* Kompilator konfiguraku na web
 * (c)17.10.1999 by Marek Zelem
 */

#include <mmm/compiler.h>
#include <mmm/lex.h>
#include <mmm/dynamic.h>
#include <stdlib.h>
#include <string.h>
#include "web_compile.h"

//#define DEBUG
#include <mmm/debug.h>

static int f_free( void *e )
{
DEBUGp(*((char**)e));
	if( *((char**)e)!=NULL )
		free( *((char**)e) );
	return(0);
}

static void del_sect( sekcia_t *s )
{	if( s->p!=NULL )	dfield_delete(s->p);
	if( s->nazov!=NULL )	free(s->nazov);
	del_menu(s->menu);
	if( ((char*)(s->data))!=NULL )	free((char*)(s->data));
	if( s->hidden!=NULL )	dd_free(s->hidden);
}

static int push_sekcia( out_t *o )
{
	dfifo_write(o->zasobnik,&(o->sekcia),1);
	o->sekcia.p=dfield_create(2,sizeof(char*),f_free);
	o->sekcia.nazov=NULL;
	o->sekcia.aktual=-1;
	((char*)(o->sekcia.data))=NULL;
	o->sekcia.menu=new_menu();
	o->sekcia.hidden=NULL;
	return(0);
}

static void out( struct compiler_out_class *this, sym_t sym, unsigned long data );

static int pop_sekcia( out_t *o )
{ mnu_t *m;
  struct dfield_dim_s *d,*h;
  char *s;
  int i,n;
  unsigned long *hp;
	if( o->sekcia.nazov!=NULL )
		o->sekcia.menu->nazov=strdup(o->sekcia.nazov);
	if( o->sekcia.menu->popis==NULL && o->sekcia.menu->nazov!=NULL )
		o->sekcia.menu->popis=strdup(o->sekcia.menu->nazov);
  	if( o->sekcia.hidden!=NULL )
	{	o->sekcia.menu->typ|=M_INCL;
		del_value(o->sekcia.p,"subor");
		del_value(o->sekcia.p,"sablona");
		del_value(o->sekcia.p,"link");
		del_value(o->sekcia.p,"url");
		del_value(o->sekcia.p,"copy");
		for(i=0;i<dd_n(o->sekcia.hidden);i++)
		{	hp=dd_entry(o->sekcia.hidden,i);
			out((struct compiler_out_class *)o,(sym_t)hp[0],hp[1]);
		}
		o->sekcia.menu->typ&=~M_INCL;
	}
	d=dfield_first_dim(o->sekcia.p);
	n=dfield_dimsize(d);
	for(i=0;i<n;i++)
	{	h=dfield_get(d,i);
		s=*((char**)dfield_get_data(h,0));
		if( !IS_USED(s) )
			warning("je nepouzita premenna \"%s\"",s);
	}
	m=o->sekcia.menu; o->sekcia.menu=NULL;
//	m->nazov=o->sekcia.nazov; o->sekcia.nazov=NULL;
//	if( m->popis==NULL && m->nazov!=NULL )
//		m->popis=strdup(m->nazov);
	del_sect(&(o->sekcia));
	dlifo_read(o->zasobnik,&(o->sekcia),1);
	add_submenu(o->sekcia.menu,m);
	return(0);
}

static void out( struct compiler_out_class *this, sym_t sym, unsigned long data )
{ out_t *o=(out_t*)this;
  char *s,**ss;
  int next;
  unsigned long hp[2];
  char buf[1024];
  static char *aktual=NULL;
  static int is_input=0;
  int n,l;
	if( o->hidden )
	{	hp[0]=sym;
		hp[1]=data;
		dd_append(o->sekcia.hidden,hp,1);
		if( sym==oHIDB )	o->hidden++;
		if( sym==oHIDE )	o->hidden--;
		return;
	}
	switch ( sym )
	{	case oSNEW:
//			printf("OUT: oSNEW \"%s\"\n",(char*)data);
			push_sekcia(o);
			o->sekcia.nazov=(char*)data;
			break;
		case oSEND:
//			printf("OUT: oSEND\n");
			if( (s=spracuj_sekciu(o))!=NULL )
				free(s);
			pop_sekcia(o);
			break;
		case oHIDE:
			if( (s=spracuj_sekciu(o))!=NULL )
				free(s);
			del_value(o->sekcia.p,"subor");
			del_value(o->sekcia.p,"sablona");
			del_value(o->sekcia.p,"link");
			del_value(o->sekcia.p,"url");
			del_value(o->sekcia.p,"copy");
			break;
		case oSSTR:
			s=spracuj_sekciu(o);
			pop_sekcia(o);
//			printf("OUT: oSSTR \"%s\"\n",s);
			o->sekcia.data=(unsigned long)s;
			is_input=0;
			break;
		case oNAM:
//			printf("OUT: oNAM \"%s\"\n",(char*)data);
			if( data==0 )
			{	o->err->error(o->err,eNOMEM,END);
				break;
			}
			if( ((char*)data)[0]=='@' )
				del_value(o->sekcia.p,(char*)data);
			o->sekcia.aktual=najdi_prem(o->sekcia.p,(char*)data);
			if( o->sekcia.aktual==-1 )
			{	dfield_add(dfield_first_dim(o->sekcia.p));
				dfield_add_data(
					dfield_get(
						dfield_first_dim(o->sekcia.p),
						-1),
					&data);
			}
			aktual=(char*)data;
			is_input=0;
			break;
		case oCPSTR:
			if( !(s=get_value(o->sekcia.p,(char*)data,1,&next)) )
				s=get_val(dfifo_data(o->zasobnik),
					dfifo_n(o->zasobnik),
					(char*)data,1,&next);
			if( s==NULL ) s="";
			free((char*)data); data=(unsigned int)(strdup(s));
			o->sekcia.data=data;
			is_input=0;
			break;
		case oFSTR:
			buf[0]='@'; strcpy(buf+1,aktual);
			if( !(s=get_value(o->sekcia.p,buf,1,&next)) )
				s=get_val(dfifo_data(o->zasobnik),
					dfifo_n(o->zasobnik),
					buf,1,&next);
			if( s!=NULL && s[0]!=0 )
			{	s=uprav_retazec(0,s,
					&(o->sekcia),dfifo_data(o->zasobnik),
					dfifo_n(o->zasobnik),aktual,
					(char*)data);
				free((char*)data); data=(unsigned int)s;
			}
			else
			{	s=uprav_retazec(0,(char*)data,
					&(o->sekcia),dfifo_data(o->zasobnik),
					dfifo_n(o->zasobnik),NULL,NULL);
				free((char*)data); data=(unsigned int)s;
			}
			if( (s=file2str((char*)data))==NULL )
			{	error("nemozem nacitat subor");
				s=strdup("");
			}
			free((char*)data); data=(unsigned int)s;
			o->sekcia.data=data;
			is_input=1;
			break;
		case oSTR:
//			printf("OUT: oSTR \"%s\"\n",(char*)data);
			if( (char*)data != NULL )
			{
			s=uprav_retazec(0,(char*)data,
				&(o->sekcia),dfifo_data(o->zasobnik),
				dfifo_n(o->zasobnik),NULL,NULL);
			free((char*)data); data=(unsigned int)s;
			}
			o->sekcia.data=data;
			is_input=1;
			break;
		case oFILTERVAL:
			n=dfield_dimsize(
				dfield_get(dfield_first_dim(o->sekcia.p),
				o->sekcia.aktual));
			if(n>1)
			{	ss=(char **)dfield_get_data(
				   dfield_get(dfield_first_dim(o->sekcia.p),
				   o->sekcia.aktual),n-1);
				s=*ss;
				*ss=filter(s,(char*)(o->sekcia.data),NULL);
				free(s);
				free((char*)(o->sekcia.data));
				(char*)(o->sekcia.data)=NULL;
			}
			else
				error("Nespravne pouzity filter");
			break;
		case oADDVAL:
			if( is_input && text_filter!=NULL )
			{	s=filter((char*)(o->sekcia.data),text_filter,aktual);
				free((char*)(o->sekcia.data));
				((char*)(o->sekcia.data))=s;
			}
			n=dfield_dimsize(
				dfield_get(dfield_first_dim(o->sekcia.p),
				o->sekcia.aktual));
			if(n>1)
			{	ss=(char **)dfield_get_data(
				   dfield_get(dfield_first_dim(o->sekcia.p),
				   o->sekcia.aktual),n-1);
				s=*ss;
				if( s!=NULL)	l=strlen(s);
				else		l=0;
				s=realloc(s,
				   l+strlen((char*)(o->sekcia.data))+1);
				strcpy(s+l,(char*)(o->sekcia.data));
				free((char*)(o->sekcia.data));
				(char*)(o->sekcia.data)=NULL;
				*ss=s;
				break;
			}
		case oVAL:
			if( is_input && text_filter!=NULL )
			{	s=filter((char*)(o->sekcia.data),text_filter,aktual);
				free((char*)(o->sekcia.data));
				((char*)(o->sekcia.data))=s;
			}
			dfield_add_data(
				dfield_get(
					dfield_first_dim(o->sekcia.p),
					o->sekcia.aktual),
				&(o->sekcia.data));
			((char*)(o->sekcia.data))=NULL;
			is_input=0;
			break;
		case oHIDB:
			if( o->sekcia.hidden==NULL )
				o->sekcia.hidden=dd_alloc(2*sizeof(long),64);
			o->hidden++;
			break;
		default:
//			printf("OUT: %04x %ld\n",sym,data);
	}
DEBUGm("...");
}

static void out_destroy( struct compiler_out_class *this )
{ out_t *p=(out_t*)this;
  int i;
	sprav_menu(NULL);	/* uvolnenie pamati */
	if( p->zasobnik!=NULL )
	{	for(i=dfifo_n(p->zasobnik)-1;i>=0;i--)
			del_sect(dfifo_entry(p->zasobnik,i));
		dfifo_delete(p->zasobnik);
	}
	del_sect(&(p->sekcia));
	free(this);
	return;
}

struct compiler_out_class *out_create( compiler_class_t *c )
{ out_t *p;
	if( (p=malloc(sizeof(out_t)))==NULL )
		return(NULL);
	p->meta.destroy=out_destroy;
	p->meta.usecount=0;
	p->meta.out=out;
	p->err=c->err;
	if( (p->zasobnik=dfifo_create(sizeof(sekcia_t),4))==NULL )
	{	free(p);
		return(NULL);
	}
	if( (p->sekcia.p=dfield_create(2,sizeof(char*),f_free))==NULL )
	{	dfifo_delete(p->zasobnik);
		free(p);
		return(NULL);
	}
	p->sekcia.nazov=NULL;
	p->sekcia.aktual=-1;
	p->sekcia.data=(unsigned long)(NULL);
	p->sekcia.menu=new_menu();
	p->sekcia.hidden=NULL;
	p->hidden=0;
	return((struct compiler_out_class *)p);
}

