/* Kompilator konfiguraku na web
 * uprava vzoru
 * (c)23.10.1999 by Marek Zelem
 */

#include <mmm/dynamic.h>
#include <stdlib.h>
#include <string.h>
#include "web_compile.h"

int najdi_prem( dfield_t *p, char *name )
{ struct dfield_dim_s *d,*h;
  char *s;
  int i,n;
	d=dfield_first_dim(p);
	n=dfield_dimsize(d);
	for(i=0;i<n;i++)
	{	h=dfield_get(d,i);
		s=*((char**)dfield_get_data(h,0));
		if( !strcmp(s,name) )
			return(i);
	}
	return(-1);
}

/* nr - 1-n */
char *get_value( dfield_t *p, char *name, int nr, int *next )
{ struct dfield_dim_s *d,*h;
  char *s;
  int i,n;
	d=dfield_first_dim(p);
	n=dfield_dimsize(d);
	for(i=0;i<n;i++)
	{	h=dfield_get(d,i);
		s=*((char**)dfield_get_data(h,0));
		if( !strcmp(s,name) )
		{	n=dfield_dimsize(h);
			if( n==1 )	return(NULL);
			SET_USED(s);
			if( nr<n-1 && next!=NULL )	*next=1;
			if( nr>n-1 )	nr=n-1;
			s=*((char**)dfield_get_data(h,nr));
			return(s);
		}
	}
	return(NULL);
}
char *get_val( sekcia_t *stack, int stacksize, char *name, int nr, int *next )
{ char *s;
	while( stacksize>0 )
	{	stacksize--;
		if( (s=get_value(stack[stacksize].p,name,nr,next))!=NULL )
			return(s);
	}
	return(NULL);
}

/* format vzoru: vo vzore sa %nazov% nahradza za hodnotu
 *		 , %#% za cislo iteracie
 *		 a %% sa nahradi za %
 */
char *uprav_vzor( char *vzor, sekcia_t *s, sekcia_t *stack, int stacksize )
{	return( uprav_retazec(1,vzor,s,stack,stacksize,NULL,NULL) );
}
char *uprav_retazec( int m, char *vzor, sekcia_t *s, sekcia_t *stack, int stacksize, char *n1, char *v1 )
{ ddata_t *d;
  char *vz,*p,*popis=NULL;
  int i;
  int n,next,je_sub;
  char buf[128];
	if( (d=dd_alloc(1,128))==NULL )
		return(NULL);
	n=0; next=1;
	while( next )
	{	next=0; n++;
		je_sub=0;
		if( m )	popis=get_value(s->p,"nazov",n,&next);
		vz=vzor;
		while( *vz!=0 )
		{	for(i=0;vz[i]!=0 && vz[i]!='%';i++);
			if(i>0)
			{	dd_append(d,vz,i);
				vz+=i;
			}
			if( vz[0]=='%' )
			{	for(i=1;vz[i]!=0 && vz[i]!='%';i++);
				if( vz[i]==0 ) goto Err;
				if( i==1 )
				{	dd_append(d,vz,1);
				}
				else if(vz[1]=='*')
				{ int ln,l;
					vz[i]=0;
					l=0,ln=1;
					while(ln)
					{ ln=0; l++;
					p=get_value(s->p,vz+2,l,&ln);
					if( p==NULL )
				   	  p=get_val(stack,stacksize,vz+2,l,&ln);
					if( p!=NULL )
					  dd_append(d,p,strlen(p));
					else
				   	  warning("je nedefinovana premenna %s",vz+2);
					}
					vz[i]='%';
				}
				else
				{
				vz[i]=0;
				if( n1!=NULL && !strcmp(vz+1,n1) )
				{	p=v1;
				}
				else if( !strcmp(vz+1,"#") )
				{	sprintf(buf,"%d",n);
					p=buf; je_sub=1;
				}
				else if( m && !strcmp(vz+1,"menu") )
				{	p=sprav_menu(s);
				}
				else	p=get_value(s->p,vz+1,n,&next);
				if( p==NULL && !strcmp(vz+1,"sekcia") )
					p=s->nazov;
				if( p==NULL )
				   p=get_val(stack,stacksize,vz+1,n,&next);
				if( p!=NULL )
					dd_append(d,p,strlen(p));
				else
				   warning("je nedefinovana premenna %s",vz+1);
				vz[i]='%';
				}
				vz+=i+1;
			}
		}
		if( m && je_sub && (n>1 || next) )
			add_nsubmenu(s->menu,n,popis);
		if( !m ) next=0;
	}
	if( m && /* n==1 && */ popis!=NULL && s->menu->popis==NULL )
			s->menu->popis=strdup(popis);
	{ char c=0; dd_append(d,&c,1); }
	/* dd_tostring(d); */
	return( dd_extract(d) );
Err:	dd_free(d);
	return(NULL);
}

int del_value( dfield_t *p, char *name )
{ struct dfield_dim_s *d,*h;
  char *s;
  int i,n;
	d=dfield_first_dim(p);
	n=dfield_dimsize(d);
	for(i=0;i<n;i++)
	{	h=dfield_get(d,i);
		s=*((char**)dfield_get_data(h,0));
		if( !strcmp(s,name) )
		{	s[1]=s[strlen(s)+1];
			s[0]=0;
			return(1);
		}
	}
	return(0);
}
